var infomigas = {
    endpoint: "https://jsonplaceholder.typicode.com",
    projectsgitlab: "https://gitlab.vitalinux.educa.aragon.es/api/v4/projects",
    //rutacentros: "/blob/master/usr/share/vitalinux/conf-centro/vx-centro.conf.json",
    rutajson: "repository/files/usr%2Fshare%2Fvitalinux%2Fconf-centro%2Fvx-centro.conf.json/raw?ref=master",
    rutaserver: "https://migasfree.educa.aragon.es/",
    //rutaserver: "http://localhost/",
    rutaapi: "https://migasfree.educa.aragon.es/api/v1/token",
    token: "2b70ddbcceaf15d59f7fb69f1210184fe51937dd",
    //rutaapi: "http://localhost/api/v1/token",
    internal_deployment: "/deployments/internal-sources",
    external_deployment: "/deployments/external-sources",
}

// function getToken(username = "migasfree-play", password = "migasfree-play") {
//     $.ajax({
//         url: global.protocol + "://" + global.server + "/token-auth/",
//         type: "POST",
//         data: { username: username, password: password },
//         success(data) {
//             const fs = require("fs");
//             global.token = "token " + data.token;
//             fs.writeFileSync("token", data.token);
//         },
//         error(jqXHR, textStatus, errorThrown) {
//             swal({
//                 title: "Server: " + global.server,
//                 text: "Token:" + jqXHR.responseText,
//                 type: "error",
//                 confirmButtonColor: colorTheme,
//                 showCancelButton: false,
//             }).then(
//                 function () {
//                     gui.App.quit();
//                 },
//                 function (dismiss) {
//                     // dismiss can be 'overlay', 'cancel', 'close', 'esc', 'timer'
//                     if (dismiss === "cancel") {
//                         // nothing
//                     }
//                 }
//             );
//         },
//     });
// }

function ObtenerNiveles(app) {
    // Extrae los niveles de la App extrayéndolos donde hay unas {}:
    // Regex que permite obtener los niveles que tenemos entre llaves {}:
    let regex = /\{([^}]*)\}/;
    let desc = app.descripcion ? app.descripcion : app.description
    if (regex.test(desc)) {
        return desc.match(regex)[1]
            .replace(/[;,.]+/g, ';')
            .replace(/;+| *; */, ';')
            .split(";")
    }
    else {
        return ["Todos los niveles"]
    }
}

function ObtenerCategoriaLinux(app) {
    // Eliminamos los links de tipo markdown que puede dar problemas al buscar las categorías linux indicadas como meta-información:
    let regex_link_markdown = /\[([^\]]+)\]\(([^)]+)\)/g;
    let regex = /\[([^\]]*)\]/;
    let desc = app.descripcion ? app.descripcion : app.description
    if (regex.test(desc)) {
        return desc.replace(regex_link_markdown, '')
            .match(regex)[1]
            .replace(/[;,.]+/g, ';')
            .replace(/;+| *; */, ';')
            .split(";")
            .map(el => el.trim().charAt(0).toUpperCase() + el.trim().slice(1).toLowerCase())
    }
    else {
        return [app.category.name]
    }
}

async function consultarListaApps() {
    let urlConsultaListaApps = `${infomigas.rutaapi}/catalog/apps`
    let token_docs = infomigas.token
    let pagina = 1
    let respuesta_api = ""
    let datos = []
    do {
        urlConsultaListaApps = `${infomigas.rutaapi}/catalog/apps/?page=${pagina}`
        console.log(`=> Número de página de apps: ${pagina}`)
        respuesta_api = await axios
            .get(urlConsultaListaApps, {
                headers: {
                    "Content-Type": "application/json",
                    Authorization: "Token " + token_docs,
                },
            })
            .catch((e) => {
                console.log(e);
            });
        datos = datos.concat(respuesta_api.data.results)
        // console.log(datos)
        pagina = pagina + 1
        console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: La siguiente pagina de la que extraer más aplicaciones es => ${respuesta_api.data.next}. Tipo de variable: ${typeof respuesta_api.data.next}`)
        // El formatdo de data.next es un string del tipo: https://migasfree.educa.aragon.es/api/v1/token/catalog/apps/?page=3
        // Cuando ya no hay más páginas se convierte en un objeto "null"
    } while (typeof respuesta_api.data.next === "string");
    // La respuesta de la API es un array de objetos (100 por consulta) con los siguientes campos:
    // 1. Array con información sobre la etiqueta o etiquetas a la que se aplica/dispone la aplicación:
    // available_for_attributes.length (p.e. "1"): número de etiquetas o atributos a los que se les asocia la aplicación
    // available_for_attributes[0].property_att.id (p.e. "1"), available_for_attributes[0].property_att.prefix (p.e. "SET")
    // available_for_attributes[0].value (p.e. "ALL SYSTEMS")
    // 2. Categoría de la aplicación: category.id, category.name
    // 3. Fecha de creación: created_at (p.e. "2022-02-01T09:01:32.912209")
    // 4. Descripción de la aplicación: description
    // 5. Icono: icon
    // 6. Identificador: id
    // 7. Nivel de usuario: level.id (p.e. "U"), level.name (p.e. "Usuario/a")
    // 8. Nombre: name
    // 9. Array de proyectos asignados y paquete a instalar:
    // package_by_project.length: número de proyectos asignados
    // package_by_project[0].id, package_by_proyect[].application
    // package_by_project[0].packages_to_install.length (número de paquetes a instalar)
    // package_by_project[0].packages_to_install[0] (p.e. "Gimp", el nombre del paquete)
    // package_by_project[0].project.id, package_by_project[0].project.name
    console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: Datos de Todas las Apps`)
    console.log(datos)

    const paquetes = [];
    for (const item of datos) {
        const proyecto = item.packages_by_project.find(pkgs => pkgs.project.name.toString() === global.project.toString());
        if (proyecto) {
            paquetes.push(...proyecto.packages_to_install);
        }
    }
    console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: global.packages opción 2`)
    console.log(paquetes.join(" "))
    global.packages = paquetes.join(" ");
    console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: Vamos a instaledPkgs. global.packages => ${global.packages}`)
    global.packagesInstalled = installedPkgs(global.packages);
    console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: Terminado instaledPkgs. global.packagesInstalled => ${global.packagesInstalled}`)


    // Antes de asociar los datos consultados a la variable global.datos, vamos a ordenarla y a mapear los datos que realmente necesita la app:
    console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: Vamos a mapear y filtrar los datos de las Aplicaciones`)
    global.datos = datos.sort((a, b) => a.name.localeCompare(b.name))
        // Mapeamos los datos antes de mandarlos
        .map((el, index) => {
            return {
                name: el.name,
                category: el.category,
                category_vitalinux: obtenerCategoriaLinux(el),
                levels: obtenerNiveles(el),
                description: parsearDescripcion(el.description),
                level: el.level,
                packages_by_project: el.packages_by_project.filter((item, index) => item.project.name == global.project),
                icon: el.icon,
                created_at: el.created_at,
                score: el.score,
                available_for_attributes: el.available_for_attributes
            }
        })

    console.log(`#> ${new Date().toLocaleTimeString()} consultarListaApps: Datos mapeados y filtrados => global.datos`)
    console.log(global.datos)

    // Indicamos que ya hemos terminado de consultar todas las Apps disponibles
    global.flag_apps = true;
    // Escondemos el spinner referente a la carga de Apps:
    $("#preload-next").hide();
}